/*
 * Auto-Regressive filter, first order
 * 
 * Copyright (C) 2010  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#define PARM_A (1 << PARM_A_SHIFT)

#if (PARM_A_SHIFT > 8)
#error "unsupported A, up to 2^8 is supported"
#endif

/*
 * The output is 15-bit.
 */

static int16_t f_y;
static int8_t f_e;

FILTER_CODE
{
	register int s;
	register int v;

	/*
	 * First order ARI with 1-st order error feedback
	 */
	s = PARM_B * x - f_y + f_e;
	v = s + (PARM_A / 2);
	f_e = s - (v & ~(PARM_A - 1));
       	v = v >> PARM_A_SHIFT;
	f_y += v;
}
